/************************************************************************
*
* Device     : RX/RX200/RX210
*
* File Name  : hwsetup.c
*
* Abstract   : Hardware Setup file.
*
* History    : 1.00  (2010-12-17)  [Hardware Manual Revision : 0.10]
*
* NOTE       : THIS IS A TYPICAL EXAMPLE.
*
* Copyright (C) 2010 Renesas Electronics Corporation.
* and Renesas Solutions Corp.
*
************************************************************************/
/*----------------------------------------------------------------------
    CN[h
----------------------------------------------------------------------*/
#include "iodefine.h"
/*----------------------------------------------------------------------
    萔`
----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
    vg^Cv錾
----------------------------------------------------------------------*/
extern void HardwareSetup(void);
void r_init_clock( void );
void port_init(void);

/*----------------------------------------------------------------------
    \[XR[h
----------------------------------------------------------------------*/
/* ݒ */
void HardwareSetup(void)
{
    r_init_clock();
    port_init();
}

/* NbN̏ݒ */
void r_init_clock(void)
{
    volatile unsigned int wk;

    SYSTEM.PRCR.WORD    = 0xA50F;       /* veNgWX^̉ */
                                        /* b15-b8FPRKEY A5ŌŒ */
                                        /* b7-b4 F\rbg 0ŌŒ */
                                        /* b3    FPRC3 = 1(LVD֘AWX^݋) */
                                        /* b2    FPRC2 = 1([p[^C}֘AWX^݋) */
                                        /* b1    FPRC1 = 1(샂[hAd͒ጸ@\݋) */
                                        /* b0    FPRC0 = 1(NbNH݋) */

    SYSTEM.VRCR = 0;                    /* dM[^䃌WX^(VXeNbN\[XύXO00h) */

    /* CNbNݒ */
    PORT3.PMR.BYTE = 0xC0;              /* P37,P36Ӌ@\ƂĎgp(NbNɐڑĂ|[g) */
    SYSTEM.MOFCR.BYTE = 0x30;           /* MODRV2 16MHZ`20MHZ */
    SYSTEM.MOSCWTCR.BYTE = 0x0D;        /* CNbNUEFCgԐݒF҂ = 131072TCN */
    SYSTEM.MOSCCR.BYTE = 0x00;          /* CNbNU퓮 */
    for( wk = 10000; wk > 0; wk-- );
    SYSTEM.SCKCR.LONG = 0x00001010;     /* PCLKD,PCLKB,BCLKS1ɂ(\rbgb12,b41ɂ) */
    SYSTEM.SCKCR3.WORD = 0x0200;        /* b10 = 0 */
                                        /* b9  = 1 */
                                        /* b8  = 0(ȏ̑gݍ킹ŁuCNbNUvIƂȂ) */
    SYSTEM.PRCR.WORD = 0xA500;          /* veNgWX^̐ݒ */
}

/* |[g̏ݒ */
void port_init(void)
{
    /*|[go̓f[^ݒ*/
    PORTH.PODR.BIT.B3 = 0;              /* D4(LED) */
    PORTH.PODR.BIT.B2 = 0;              /* D3(LED) */

    /*|[go͕ݒ*/
    PORTH.PDR.BIT.B3 = 1;               /* PH3(D4(LED))o */
    PORTH.PDR.BIT.B2 = 1;               /* PH2(D3(LED))o */
    PORTH.PDR.BIT.B1 = 0;               /* PH1(SW2) */

    /*|[g[hݒ*/
    PORTH.PMR.BIT.B3 = 0;               /* ėpo̓|[gƂĐݒ */
    PORTH.PMR.BIT.B2 = 0;
    PORTH.PMR.BIT.B1 = 0;
}


